/*
 *  
 *  $Id: toolpan.h 4490 2011-12-14 09:56:19Z carlos $
 *  Ginkgo CADx Project
 *
 *  Copyright 2008-10 MetaEmotion S.L. All rights reserved.
 *  http://ginkgo-cadx.com
 *
 *  This file is licensed under LGPL v3 license.
 *  See License.txt for details
 *
 *
 */
#pragma once
#include <api/api.h>
#include <export/itoolpan.h>
#include <api/toolhandlers/ipanhandler.h>
#include <widgets/wpan.h>


namespace GNC {

	class EXTAPI ToolPan : public GNC::GCS::IToolPan, public GNC::GCS::ToolHandlers::IPanHandler {
	public:
		typedef GNC::GCS::Eventos::EventoRaton       TEventoRaton;
		typedef GNC::GCS::Eventos::EventoTeclado     TEventoTeclado;
		typedef GNC::GCS::Widgets::WPanBuilder       TBuilder;
		ToolPan();
		~ToolPan();

//region "Realización de la interfaz IHerramienta"

		// Setup de paneles
		virtual void CrearPaneles( wxPanel* panel );

//endregion

		virtual void ConectarContratoFalso(bool activar);
		virtual void SetVistaActiva(GNC::GCS::IVista* pVista);
		virtual void ConectarContratos(bool activar);

//region "Eventos refinados desde los paneles"

//endregion

//region "Pan Handler realization"
		virtual void Pan();
//endregion
		
	protected:

		TBuilder*            m_pBuilder;
	};
}
